require 'yaml'

module Wildsight
  module Agent

    class Config

      def self.load(file = (ENV['WILDSIGHT_CONFIG_FILE'] || 'config/wildsight.yml'))
        options = YAML.load(File.read(File.expand_path('../config.yml', __FILE__)))
        options = options.merge(file) if file.kind_of?(Hash)
        if file.kind_of?(String) && File.exist?(file)
          options = options.merge(YAML.load(File.read(file)))
        end
        Config.new(options)
      end

      def initialize(values = {})
        @values = values
      end

      def method_missing(name, *args)
        name = name.to_s
        self[name]
      end

      def [](name)
        name = name.to_s
        @values[name] = Config.new(@values[name]) if @values[name].kind_of?(Hash)
        @values[name]
      end

    end

  end
end