require 'logger'

module Wildsight
  module Context

    class Logger < ::Logger

      def initialize(context = nil)
        @context = context
        super(self)
        self.formatter = self
      end

      def call(severity, time, progname, msg)
        payload = {
            :severity => severity,
            :facility => progname,
            :message => msg.to_s.strip
        }
        context = @context || Wildsight::Context.detect
        context.event(:log, payload, {}) if context
        return nil
      end

      def write(message)
      end

      def close
      end

    end

  end
end