require 'wildsight/metrics/counter'
require 'wildsight/metrics/gauge'
require 'wildsight/metrics/statistics'

module Wildsight
  module Metrics

    class Metrics

      def initialize
        @metrics = {}
      end

      def counter(name)
        metric(name, ::Wildsight::Metrics::Counter)
      end

      def gauge(name)
        metric(name, ::Wildsight::Metrics::Gauge)
      end

      def statistics(name)
        metric(name, ::Wildsight::Metrics::Statistics)
      end

      def histogram(name)
        metric(name, ::Wildsight::Metrics::Histogram)
      end

      def metric(name, clazz)
        @metrics[name] ||= clazz.new
      end

    end

  end
end