module Wildsight
  module Rack

    class BottomMiddleware

      def initialize(app)
        @app = app
      end

      def call(env)
        context = Wildsight::Rack.detect_context(env)
        response = context.profiler.duration(:rails) { @app.call(env) }
        return response
      rescue Exception => e
        context.event(:exception, extract(e))
        raise e
      end

      def extract(exception)
        data = {:message => exception.message, :name => exception.class.name, :backtrace => exception.backtrace}
        data[:cause] = extract_exception(exception.cause) if exception.cause
        return data
      end

    end

  end
end