require 'net/http'

module Wildsight
  module Transport

    class NetHttpTransport

      def initialize(agent, config)
        @agent = agent
        @config = config
        @uri = URI(File.join(@config['transport']['url'], 'ingest', @config['transport']['key']))
      end

      def send(payload)
        begin
          @agent.logger.log(:debug) { Net::HTTP.post_form(@uri, payload: MultiJson.dump(payload)).inspect }
        rescue Exception => e
          @agent.logger.log(:error) { e }
        end
      end

    end

  end
end