require 'wildsight/version'

require 'socket'

module Wildsight

  def self.source=(value)
    @source = value
  end

  def self.source
    @source ||= 'ruby'
  end

  def self.host=(value)
    @host = value
  end

  def self.host
    @host ||= Socket.gethostname
  end

end

require 'wildsight/transport/transport'
require 'wildsight/metrics/metrics'
require 'wildsight/profiler/profiler'
require 'wildsight/context/context'
require 'wildsight/context/logger'
require 'wildsight/agent/agent'


if defined?(Rack)
  Wildsight.source = 'rack'

  require 'wildsight/rack/rack'
  require 'wildsight/rack/top_middleware'
  require 'wildsight/rack/bottom_middleware'
end

if defined?(Rails)
  Wildsight.source = 'rails'

  require 'wildsight/rails/action_controller'
  require 'wildsight/rails/active_record'
  require 'wildsight/rails/railtie'
end
